<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- 
IGAC proyecto SNC
@author: lorena.salamanca
  
CU-NP-FA-206 Gestionar proyecto de nomenclatura vial para fines catastrales
 
@modified lorena.salamanca Se actualiza para la migracion de PrimeFaces 3.2
-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                xmlns:actualizacion="http://java.sun.com/jsf/composite/actualizacion"
                template="/templates/generalCU.xhtml">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Gestionar proyecto de nomenclatura vial::.
    </ui:define>

    <ui:define name="content">
        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" onerror="statusDialog.hide();" />
        <p:focus />

        <actualizacion:actualizacionResumenCC id="actualizacionResumen"
                                              actualizacionParam="#{gestionarProyectoDeNomenclaturaVial.actualizacionSeleccionada}"/>

        <h:form prependId="false" id="gestionarProyectoNomenclaturaVialForm">

            <p:messages id="msgsGestionarProyectoNomenclaturaVial"
                        showDetail="false" globalOnly="false" />

            <h:panelGrid cellpadding="5" cellspacing="5">

                <p:panel header="Gestionar proyecto de nomenclatura vial">

                    <h:panelGrid columns="3" rowClasses="columnOnTop">

                        <h:panelGrid cellpadding="5" cellspacing="5" id="columnaUno">

                            <h:panelGrid id="normasPanel" width="100%">
                                <h:panelGrid columns="3">
                                    <h:outputLabel for="normasMenu"
                                                   value="Relación de normas vigentes: "
                                                   styleClass="outputLabelStyle" />

                                    <p:spacer height="10" />
                                    <h:selectOneMenu id="normasMenu"
                                                     value="#{gestionarProyectoDeNomenclaturaVial.nuevaNorma}">
                                        <f:selectItems
                                            value="#{gestionarProyectoDeNomenclaturaVial.departamentosColombia}" />
                                        <p:ajax
                                            update="normasTable, msgsGestionarProyectoNomenclaturaVial"
                                            process="@this"
                                            listener="#{gestionarProyectoDeNomenclaturaVial.agregarNorma}">
                                        </p:ajax>
                                    </h:selectOneMenu>
                                </h:panelGrid>

                                <p:dataTable
                                    value="#{gestionarProyectoDeNomenclaturaVial.normasTabla}"
                                    id="normasTable" var="nuevaNorma"
                                    selection="#{gestionarProyectoDeNomenclaturaVial.selectedNorma}"
                                    emptyMessage="No hay normas relacionadas" paginator="true"
                                    rows="5"
                                    paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                    paginatorPosition="bottom" rowsPerPageTemplate="5,10,15">

                                    <p:column headerText="Opciones" style="width:32px">
                                        <center><p:commandButton
                                                update=":gestionarProyectoNomenclaturaVialForm:normasPanel"
                                                action="#{gestionarProyectoDeNomenclaturaVial.desvincularNorma}"
                                                icon="ui-icon-trash" title="Eliminar" process="@this">
                                                <f:setPropertyActionListener value="#{nuevaNorma}"
                                                                             target="#{gestionarProyectoDeNomenclaturaVial.selectedNorma}" />
                                            </p:commandButton></center>
                                    </p:column>

                                    <p:column headerText="Normas incluidas">
                                        <center><h:outputText styleClass="outputTextStyle"
                                                              value="#{nuevaNorma}">
                                            </h:outputText></center>
                                    </p:column>
                                </p:dataTable>
                            </h:panelGrid>

                            <h:panelGrid columns="3">

                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Nombre del alcalde:"
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>

                                <h:inputText id="nombreAlcalde" required="true"
                                             value="#{gestionarProyectoDeNomenclaturaVial.nombreAlcalde}"
                                             size="43" />
                                <p:message for="nombreAlcalde" display="icon"
                                           id="nombreAlcaldeMsg" />

                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Eje de referencia para las calles:"
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>

                                <h:inputTextarea rows="2" cols="40" id="referenciaCalles"
                                                 required="true" onkeydown="controlarNroChars(this, 100, true)"
                                                 onkeyup="controlarNroChars(this, 100, true)"
                                                 value="#{gestionarProyectoDeNomenclaturaVial.referenciaCalles}" />
                                <p:message for="referenciaCalles" display="icon"
                                           id="referenciaCallesMsg" />

                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Eje de referencia para las carreras:"
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>

                                <h:inputTextarea rows="2" cols="40" id="referenciaCarreras"
                                                 required="true" onkeydown="controlarNroChars(this, 100, true)"
                                                 onkeyup="controlarNroChars(this, 100, true)"
                                                 value="#{gestionarProyectoDeNomenclaturaVial.referenciaCarreras}" />
                                <p:message for="referenciaCarreras" display="icon"
                                           id="referenciaCarrerasMsg" />
                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Punto de partida, carrera primera:"
                                                   styleClass="outputLabelStyle" />
                                    <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                                </h:panelGrid>

                                <h:inputTextarea rows="2" cols="40" id="puntoPartida"
                                                 required="true" onkeydown="controlarNroChars(this, 100, true)"
                                                 onkeyup="controlarNroChars(this, 100, true)"
                                                 value="#{gestionarProyectoDeNomenclaturaVial.puntoPartida}" />
                                <p:message for="puntoPartida" display="icon"
                                           id="puntoPartidaMsg" />

                                <h:panelGrid columns="2">
                                    <h:outputLabel value="Casos conocidos de vías de uso privado:"
                                                   styleClass="outputLabelStyle" />
                                    <p:spacer />
                                </h:panelGrid>
                                <h:inputTextarea rows="2" cols="40"
                                                 onkeydown="controlarNroChars(this, 100, true)"
                                                 onkeyup="controlarNroChars(this, 100, true)"
                                                 value="#{gestionarProyectoDeNomenclaturaVial.casosConocidos}" />
                                <p:spacer />
                            </h:panelGrid>
                        </h:panelGrid>

                        <p:spacer width="20" />

                        <h:panelGrid id="columnaDos" width="100%" cellpadding="5"
                                     cellspacing="5">

                            <h:panelGrid width="100%">
                                <h:panelGrid columns="2" rowClasses="columnOnTop"
                                             id="agregarCondicionesPG" width="100%">
                                    <h:outputLabel value="Condiciones adicionales:"
                                                   styleClass="outputLabelStyle" for="nuevaCondicionText" />
                                    <h:inputTextarea id="nuevaCondicionText" rows="2" cols="70"
                                                     onkeydown="controlarNroChars(this, 100, true)"
                                                     onkeyup="controlarNroChars(this, 100, true)"
                                                     value="#{gestionarProyectoDeNomenclaturaVial.nuevaCondicionAdicional.texto}" />
                                </h:panelGrid>

                                <p:outputPanel layout="block" style="text-align:right">
                                    <p:commandButton value="Adicionar" icon="ui-icon-plus"
                                                     title="Agregar condición" process="columnaDos"
                                                     action="#{gestionarProyectoDeNomenclaturaVial.agregarCondicionAdicional}"
                                                     update=":gestionarProyectoNomenclaturaVialForm:columnaDos, :gestionarProyectoNomenclaturaVialForm:msgsGestionarProyectoNomenclaturaVial"
                                                     id="agregarCondicionAdicionalBtn" />
                                </p:outputPanel>
                            </h:panelGrid>

                            <p:dataTable
                                value="#{gestionarProyectoDeNomenclaturaVial.listaCondicionesAdicionales}"
                                var="condicionAdicionalVar" id="condicionAdicionalTable"
                                emptyMessage="No hay condiciones adicionales relacionadas"
                                paginator="true" rows="5"
                                paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                paginatorPosition="bottom" rowsPerPageTemplate="5,10,15">

                                <p:column style="width:60px" headerText="Opciones">
                                    <center>
                                        <p:commandButton
                                            update=":gestionarProyectoNomenclaturaVialForm:columnaDos"
                                            process="@this" id="modificarCondicionalBtn"
                                            icon="ui-icon ui-icon-pencil" label="Editar condicional"
                                            action="#{gestionarProyectoDeNomenclaturaVial.editarCondicional}" 
                                            title="Editar condicional">
                                            <f:setPropertyActionListener value="#{condicionAdicionalVar}"
                                                                         target="#{gestionarProyectoDeNomenclaturaVial.nuevaCondicionAdicional}" />
                                            <f:setPropertyActionListener value="true"
                                                                         target="#{gestionarProyectoDeNomenclaturaVial.editModeBool}" />

                                        </p:commandButton> <p:commandButton icon="ui-icon-trash" title="Eliminar"
                                                                            update=":gestionarProyectoNomenclaturaVialForm:columnaDos"
                                                                            action="#{gestionarProyectoDeNomenclaturaVial.quitarCondicionAdicional}"
                                                                            process="@this">
                                            <f:setPropertyActionListener value="#{condicionAdicionalVar}"
                                                                         target="#{gestionarProyectoDeNomenclaturaVial.nuevaCondicionAdicional}" />
                                        </p:commandButton>

                                    </center>
                                </p:column>
                                <p:column>
                                    <f:facet name="header">
                                        <h:outputText value="Texto de artículos adicionales" />
                                    </f:facet>
                                    <h:outputText value="#{condicionAdicionalVar.texto}" />
                                </p:column>

                            </p:dataTable>

                            <h:panelGrid>
                                <h:panelGrid columns="2" rowClasses="columnOnTop">
                                    <h:outputLabel
                                        value="Relación de entidades a las que se les debe informar asignación y cambios de numeración:"
                                        styleClass="outputLabelStyle" for="nuevaEntidadText" />

                                    <h:selectOneMenu id="entidadesMenu" disabled="true"
                                                     value="#{gestionarProyectoDeNomenclaturaVial.nuevaNorma}">
                                        <f:selectItems
                                            value="#{gestionarProyectoDeNomenclaturaVial.departamentosColombia}" />
                                        <p:ajax
                                            update="entidadRelacionadaTable, msgsGestionarProyectoNomenclaturaVial"
                                            process="@this"
                                            listener="#{gestionarProyectoDeNomenclaturaVial.agregarEntidadRelacionada}">
                                        </p:ajax>
                                    </h:selectOneMenu>
                                </h:panelGrid>
                                <p:outputPanel layout="block" style="text-align:right">

                                    <p:commandButton value="Adicionar" icon="ui-icon-plus"
                                                     title="Agregar relación" process="columnaDos" disabled="true"
                                                     action="#{gestionarProyectoDeNomenclaturaVial.agregarEntidadRelacionada}"
                                                     update=":gestionarProyectoNomenclaturaVialForm:columnaDos, :gestionarProyectoNomenclaturaVialForm:msgsGestionarProyectoNomenclaturaVial"
                                                     id="agregarEntidadRelacionadaBtn" />
                                </p:outputPanel>
                            </h:panelGrid>

                            <p:dataTable
                                value="#{gestionarProyectoDeNomenclaturaVial.listaEntidadesRelacionadas}"
                                var="entidadRelacionadaVar" id="entidadRelacionadaTable"
                                emptyMessage="No hay entidades relacionadas" paginator="true"
                                rows="5"
                                paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                paginatorPosition="bottom" rowsPerPageTemplate="5,10,15">

                                <p:column style="width:32px" headerText="Opciones">
                                    <p:commandButton icon="ui-icon-trash" title="Eliminar"
                                                     update=":gestionarProyectoNomenclaturaVialForm:columnaDos"
                                                     action="#{gestionarProyectoDeNomenclaturaVial.quitarEntidadRelacionada}"
                                                     process="@this">
                                        <f:setPropertyActionListener value="#{entidadRelacionadaVar}"
                                                                     target="#{gestionarProyectoDeNomenclaturaVial.nuevaEntidadRelacionada}" />
                                    </p:commandButton>
                                </p:column>

                                <p:column>
                                    <f:facet name="header">
                                        <h:outputText value="Relación de entidades" />
                                    </f:facet>
                                    <h:outputText value="#{entidadRelacionadaVar}" />
                                </p:column>

                            </p:dataTable>
                        </h:panelGrid>
                    </h:panelGrid>

                    <p:separator style="width:100%;height:3px" />
                    <p:spacer height="7" width="0" />
                    <p:outputPanel layout="block" style="text-align:right">

                        <p:commandButton value="Visualizar proyecto de acuerdo"
                                         title="Visualizar proyecto de acuerdo"
                                         label="Visualizar proyecto de acuerdo"
                                         onstart="statusDialog2.show();"
                                         oncomplete="statusDialog2.hide();	handleCompleteSIC(xhr, status, args, proyectoDeAcuerdoVisualizarWV, true)"
                                         update=":viewReport:vistaMemoForm,:gestionarProyectoNomenclaturaVialForm"
                                         action="#{gestionarProyectoDeNomenclaturaVial.guardarYVisualizarReporte}"
                                         icon="ui-icon-document">
                        </p:commandButton>

                        <p:spacer height="10" />

                        <p:commandButton value="Generar y radicar"
                                         title="Generar y radicar proyecto de acuerdo"
                                         label="Generar y radicar proyecto de acuerdo"
                                         icon="ui-icon-pin-w"
                                         update=":viewReport:vistaMemoForm, :gestionarProyectoNomenclaturaVialForm"
                                         onstart="statusDialog2.show();"
                                         oncomplete="statusDialog2.hide();handleCompleteSIC(xhr, status, args, proyectoDeAcuerdoAvanzarWV, true)"
                                         action="#{gestionarProyectoDeNomenclaturaVial.guardarYVisualizarReporte}">
                        </p:commandButton>

                        <p:spacer height="10" />

                        <p:commandButton value="Cerrar" icon="ui-icon-circle-close"
                                         immediate="true" process="@this" title="Cerrar" label="Cerrar"
                                         action="#{gestionarProyectoDeNomenclaturaVial.cerrarPaginaPrincipal}"
                                         ajax="false" />
                        <p:spacer height="0" width="10" />
                    </p:outputPanel>

                </p:panel>
            </h:panelGrid>
        </h:form>

        <p:dialog header="Detalle del trámite"
                  widgetVar="detalleTramiteEjecutarWV" modal="false" appendToBody="true"
                  resizable="true" position="center" height="480" width="960">
            <ui:include
                src="../../conservacion/ejecucion/detalleTramiteEjecucion.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesTramite}" />
                <ui:param name="currentDetallePredioWV" value="detallesPredioWV" />
            </ui:include>
        </p:dialog>

        <misc:visualizadorMemorandosCC
            id="viewReport"
            thisWVName="proyectoDeAcuerdoVisualizarWV"
            urlDocumento="#{gestionarProyectoDeNomenclaturaVial.reporte.urlWebReporte}"
            fileContent="#{gestionarProyectoDeNomenclaturaVial.reporte.streamedContentReporte}"
            documentoGenerado="#{gestionarProyectoDeNomenclaturaVial.reporte ne null}"
            radicarButtonVisible="false"            
            cancelButtonVisible="false"/>

        <misc:visualizadorMemorandosCC
            id="proyectoDeAcuerdoAvanzarModal"
            thisWVName="proyectoDeAcuerdoAvanzarWV"
            urlDocumento="#{gestionarProyectoDeNomenclaturaVial.reporte.urlWebReporte}"
            fileContent="#{gestionarProyectoDeNomenclaturaVial.reporte.streamedContentReporte}"
            documentoGenerado="#{gestionarProyectoDeNomenclaturaVial.reporte ne null}"
            radicarButtonAction="#{gestionarProyectoDeNomenclaturaVial.radicarYAvanzarProceso}"
            radicarButtonEnabled="true"
            cancelButtonEnabled="true"/>

        <p:confirmDialog appendToBody="true"
                         message="Una vez radicado el proyecto de acuerdo se avanzará el proceso. ¿Está seguro de que desea hacerlo?"
                         width="400" header="Confirmación" severity="alert"
                         widgetVar="confirmacionRadicarProyectoDeAcuerdoWV">
            <h:form>
                <p:outputPanel layout="block" style="text-align:center">
                    <p:commandButton value="Sí"
                                     id="confirmaRadicacionYAvanceProcesoBtn" icon="ui-icon-seek-next"
                                     title="Confirmar radicación y avance del proceso"
                                     label="Confirmar radicación y avance del proceso" ajax="false"
                                     onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();"
                                     action="#{gestionarProyectoDeNomenclaturaVial.radicarYAvanzarProceso}" />

                    <p:spacer width="10" />

                    <p:commandButton value="No" icon="ui-icon-close"
                                     onclick="confirmacionRadicarProyectoDeAcuerdoWV.hide()"
                                     type="button" />
                </p:outputPanel>
            </h:form>
        </p:confirmDialog>

        <misc:docViewerWithCloseDecisionCC id="docViewer"
                                           confirmUpdate="msgInfoFis" confirmDialogWV="docViewerWV"
                                           ajaxBehavior="true"
                                           selectedDocumentAtt="#{previsualizacionDocumento.rutaArchivoTemporal}"
                                           showDownloadButton="#{previsualizacionDocumento.documentoDwg}"
                                           fileContent="#{previsualizacionDocumento.reporteDTO.streamedContentReporte}"
                                           doctypeAtt="#{vistaDetallesTramite.tipoMimeDocTemporal}"
                                           headerLabel="Previsualización de documento" yesRendered="false"
                                           noLabel="Cerrar" />

    </ui:define>
</ui:composition>